using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
namespace CompileTimeTest
{
    public class WindowWrapper : IWin32Window
    {
        public WindowWrapper(Int32 handle)
        {
            _hwnd = handle;
        }

        public IntPtr Handle
        {
            get {return (IntPtr) _hwnd;}
        }

        private readonly Int32 _hwnd;
    }

    [ComVisible(true), GuidAttribute("9C7B484A-EFE1-45B2-ADE6-042601741914")]
    public class Ide
    {
        const string TestString = "InstallAware\n2012";
        public string ModuleFolder {get; set;}
        public int DesignTimeEdit(uint window, string state, ref string newState, bool displayDialog)
        {
            if(displayDialog)
            {
                DialogResult res = MessageBox.Show("Test");
                if(res == DialogResult.Cancel)
                {
                    return -1;
                }
                return TestString.Length;
            }
            newState = TestString;
            return 0;
        }

        public int DesignTimeText(string state, ref string text)
        {
            if(string.IsNullOrEmpty(text))
            {
                return "Text".Length;
            }
            text = "Text";
            return 0;
        }

        public void AboutPlugIn(Int32 window)
        {
            MessageBox.Show(new WindowWrapper(window), "An InstallAware plug-in");
        }

        public bool CompileTimeBuild(Int32 msiHandle, string state, string buildPath, bool build, ref bool fetch)
        {
            MessageBox.Show("State: " + state);
            return true;
        }
    }
}
